#ifndef __PTP_OPT_H__
#define __PTP_OPT_H__

typedef enum {
    PTP_ARG_CMD_TYPE_SET = 1,
    PTP_ARG_CMD_TYPE_GET,
    PTP_ARG_CMD_TYPE_COMMAND,
} ptp_arg_cmd_type;

typedef enum {
    PTP_ARG_IF_TYPE_ETH = 1,
    PTP_ARG_IF_TYPE_BOND,
    PTP_ARG_IF_TYPE_VLAN,
    PTP_ARG_IF_TYPE_VRF,
} ptp_arg_if_type;

typedef enum {
    PTP_ARG_GLBL_CFG_PTP = 1,
    PTP_ARG_GLBL_CFG_DOMAIN,
    PTP_ARG_GLBL_CFG_PRIO1,
    PTP_ARG_GLBL_CFG_PRIO2,
    PTP_ARG_GLBL_CFG_OFF_MIN_THRSH,
    PTP_ARG_GLBL_CFG_OFF_MAX_THRSH,
    PTP_ARG_GLBL_CFG_MPD_THRSH,
    PTP_ARG_GLBL_CFG_ACC_MSTR,
    PTP_ARG_GLBL_CFG_MSG_MODE,
    PTP_ARG_GLBL_CFG_SLAVE_ONLY,
    PTP_ARG_GLBL_CFG_TTL,
    PTP_ARG_GLBL_CFG_DSCP_EVENT,
    PTP_ARG_GLBL_CFG_DSCP_GEN,
} ptp_arg_glbl_cfg_opt;

typedef enum {
    PTP_ARG_GLBL_SHOW_CLOCK = 1,
    PTP_ARG_GLBL_SHOW_CONFIG,
    PTP_ARG_GLBL_SHOW_STATUS,
    PTP_ARG_GLBL_SHOW_COUNTERS,
    PTP_ARG_GLBL_SHOW_ACC_MSTR,
    PTP_ARG_GLBL_SHOW_FORCED_MSTR,
    PTP_ARG_GLBL_SHOW_TIME_PROPERTY,
} ptp_arg_glbl_show_opt;

typedef enum {
    PTP_ARG_GLBL_CLEAR_ACC_MSTRS = 1,
    PTP_ARG_GLBL_CLEAR_FORCED_MSTRS,
    PTP_ARG_GLBL_CLEAR_COUNTERS,
    PTP_ARG_GLBL_SET_LOGGING,
} ptp_arg_glbl_command_opt;

typedef enum {
    PTP_ARG_IF_CFG_PTP = 1,
    PTP_ARG_IF_CFG_IPV6,
    PTP_ARG_IF_CFG_FORCED_MSTR,
    PTP_ARG_IF_CFG_ANN_INTVL,
    PTP_ARG_IF_CFG_SYNC_INTVL,
    PTP_ARG_IF_CFG_DELAY_REQ_INTVL,
    PTP_ARG_IF_CFG_ANN_TIMEOUT,
    PTP_ARG_IF_CFG_DELAY_MECHANISM,
    PTP_ARG_IF_CFG_ACC_MSTR_TBL_ENBL,
} ptp_arg_if_cfg_opt;

typedef enum {
    PTP_ARG_IF_SHOW_CONFIG = 1,
    PTP_ARG_IF_SHOW_STATUS,
    PTP_ARG_IF_SHOW_COUNTERS,
    PTP_ARG_IF_SHOW_FOREIGN_MSTRS,
} ptp_arg_if_show_opt;

typedef enum {
    PTP_ARG_IF_CLEAR_COUNTERS = 1,
} ptp_arg_if_command_opt;

typedef enum {
        PTP_ARG_TYPE_BOOL = 1,
        PTP_ARG_TYPE_MODE,
        PTP_ARG_TYPE_PARENT,
        PTP_ARG_TYPE_LOG,
        PTP_ARG_TYPE_DETAIL,
        PTP_ARG_TYPE_CLKID,
        PTP_ARG_TYPE_UINT8_VALUE,
        PTP_ARG_TYPE_VALUE,
        PTP_ARG_TYPE_DSCP_VALUE,
        PTP_ARG_TYPE_INTVL,
        PTP_ARG_TYPE_DM
} ptp_arg_type;

typedef struct {
    const char *name;
} PtpCommand;

typedef struct {
    const char *name;
} PtpIfType;

typedef struct {
    const char *name;
    bool takes_arg;
    bool arg_optional;
    ptp_arg_type arg_type;
} PtpCommandOption;


typedef struct {
    ptp_arg_cmd_type cmd_type;
    ptp_arg_if_type interface_type;
    ptp_arg_type arg_type;
    bool debug_enable;
    bool global;
    bool opt_takes_arg;
    bool opt_arg_optional;
    bool opt_arg_present;

    ptp_arg_glbl_cfg_opt glbl_cfg_opt;
    ptp_arg_glbl_show_opt glbl_show_opt;
    ptp_arg_glbl_command_opt glbl_command_opt;

    ptp_arg_if_cfg_opt if_cfg_opt;
    ptp_arg_if_show_opt if_show_opt;
    ptp_arg_if_command_opt if_command_opt;

    char *type_argument; // Argument for type
    char *opt_str_argument;  // String Argument for option
    int  opt_int_argument;   // Integer Argument for option
    bool opt_bool_argument;

    const char *help_message;
} PtpParsedArgs;

PtpParsedArgs ptp_cmd_parser(int argc, char *argv[]);

#endif
